Titanium.API.info('Liste.js Start.');

//Tagebuch-Liste definieren
var Tagebuch = new Array();

// Konstruktor
function TagebuchEintrag(Laune, Eintrag)
{
	this.Laune = Laune;
	this.Eintrag = Eintrag; 
}

// Hinzufügen-Methode definieren und setzen 
function EintragHinzufuegen(Laune, Eintrag)
{
	this[this.length] = new TagebuchEintrag(Laune, Eintrag);
}

Tagebuch.EintragHinzufuegen = EintragHinzufuegen;

// Dummy-Einträge in die Liste schreiben
//Tagebuch.EintragHinzufuegen(1, 'Heute ging\'s mir richtig gut!');
//Tagebuch.EintragHinzufuegen(1, 'Die Sonne scheint und alles ist prima!');
//Tagebuch.EintragHinzufuegen(-1, 'Dunkle Wolken und Regen schlagen auf\'s Gemüt.');
//Tagebuch.EintragHinzufuegen(0, 'Man gewöhnt sich ja an alles.');
//Tagebuch.EintragHinzufuegen(1, 'Ich bin motiviert. Es geht bergauf!');

// Tagebuch laden
if (Ti.App.Properties.hasProperty('Tagebucheintraege'))
{
	Tagebuch = JSON.parse(Ti.App.Properties.getString('Tagebucheintraege'));
	Titanium.API.info('Tagebuch geladen (' + Tagebuch.length + ' Einträge).');
}

//MaxAnzahl lesen
var MaxAnzahl = 10;
if (Ti.App.Properties.hasProperty('MaxAnzahl'))
{
	MaxAnzahl = Ti.App.Properties.getInt('MaxAnzahl');
	Titanium.API.info('Max. Anzahl = ' + MaxAnzahl + '.');
}

var win = Titanium.UI.currentWindow;

// Den TableView erzeugen
var tvListe = Titanium.UI.createTableView({
	editable:true
});

// Schreibt die Daten in den TableView (insb. setzen der Icons)
function SetzeTableRow(row, n)
{
	row.title = Tagebuch[n].Eintrag;
	switch (Tagebuch[n].Laune)
	{
		case -1:
			row.leftImage = '../images/sad.png';
			break;
		case 0:
			row.leftImage = '../images/plain.png';
			break;
		case 1:
			row.leftImage = '../images/smile.png';
			break;
	}
}

// Und die einzelnen Zeilen hinzufügen
for (var n=0; n<Tagebuch.length;n++)
{
	var row = Ti.UI.createTableViewRow({color:'#000000'});
	SetzeTableRow(row, n);
	tvListe.appendRow(row);
}

// Leerer Eintrag für Hinzufügen
var row = Ti.UI.createTableViewRow({title:'Neuer Eintrag...',color:'#404040'});
tvListe.appendRow(row);

// Bei Klick auf den Eintrag soll ein Detailfenster aufgehen
tvListe.addEventListener('click', function(e)
{
	// Index des aktuellen Eintrags und dazugehörige TableViewRow merken
	var index = e.index;
	var row = e.row;

	Titanium.API.info('Eintrag (' + index + ') ausgewählt.');

	// Öffne Details-Fenster
	var wndDetails = Titanium.UI.createWindow({
		backgroundColor:'#ffffff'
	});

	// Das Textfeld für den Eintrag ganz oben, wegen der Tastatur
	var txtEintrag = Titanium.UI.createTextArea({
		value:(index < Tagebuch.length)? Tagebuch[index].Eintrag : '',
		top:20,
		width:300,
		height:150,
		suppressReturn:false
	})
	wndDetails.add(txtEintrag);
	
	// Darunter die Buttons für den Gemütszustand
	// Traurig
	var btnSad = Titanium.UI.createButton({
		backgroundImage:'../images/sad60.png',
		borderColor:((index < Tagebuch.length) && (Tagebuch[index].Laune == -1))? '#00ff00' : '#000000',
		borderWidth:3,
		borderRadius:10,
		left:Titanium.Platform.displayCaps.platformWidth/2-110,
		top:190,
		width:60,
		height:60
	});
	wndDetails.add(btnSad);

	// Beim Klick wird dieser Button aktiv (grüner Rahmen)
	btnSad.addEventListener('click', function()
	{
		btnSad.borderColor = '#00ff00';
		btnPlain.borderColor = '#000000';
		btnSmile.borderColor = '#000000';
	});

	// Unentschieden
	var btnPlain = Titanium.UI.createButton({
		backgroundImage:'../images/plain60.png',
		borderColor:((index < Tagebuch.length) && (Tagebuch[index].Laune == 0))? '#00ff00' : '#000000',
		borderWidth:3,
		borderRadius:10,
		left:Titanium.Platform.displayCaps.platformWidth/2-30,
		top:190,
		width:60,
		height:60
	});
	wndDetails.add(btnPlain);

	// Beim Klick wird dieser Button aktiv (grüner Rahmen)
	btnPlain.addEventListener('click', function()
	{
		btnSad.borderColor = '#000000';
		btnPlain.borderColor = '#00ff00';
		btnSmile.borderColor = '#000000';
	});

	// Glücklich
	var btnSmile = Titanium.UI.createButton({
		backgroundImage:'../images/smile60.png',
		borderColor:((index < Tagebuch.length) && (Tagebuch[index].Laune == 1))? '#00ff00' : '#000000',
		borderWidth:3,
		borderRadius:10,
		left:Titanium.Platform.displayCaps.platformWidth/2+50,
		top:190,
		width:60,
		height:60
	});
	wndDetails.add(btnSmile);
	
	// Beim Klick wird dieser Button aktiv (grüner Rahmen)
	btnSmile.addEventListener('click', function()
	{
		btnSad.borderColor = '#000000';
		btnPlain.borderColor = '#000000';
		btnSmile.borderColor = '#00ff00';
	});

	// Und noch die Buttons Schließen und Speichern
	var btnClose = Titanium.UI.createButton({
		title:'Schließen',
		left:20,
		top:270,
		width:Titanium.Platform.displayCaps.platformWidth/2-30,
		height:30
	});
	wndDetails.add(btnClose);
	
	btnClose.addEventListener('click', function()
	{
		Titanium.API.info('Eintrag schliessen.');
		wndDetails.close();
	});

	var btnSave = Titanium.UI.createButton({
		title:'Speichern',
		left:Titanium.Platform.displayCaps.platformWidth/2 + 10,
		top:270,
		width:Titanium.Platform.displayCaps.platformWidth/2-30,
		height:30
	});
	wndDetails.add(btnSave);
	
	btnSave.addEventListener('click', function()
	{
		if (index < Tagebuch.length)
		{
			Titanium.API.info('Eintrag speichern.');
		}
		else
		{
			Titanium.API.info('Eintrag neu anlegen.');
			
			// Neuen Tagebucheintrag anlegen. Dieser benutzt die alte Neuerstellen-Row
			Tagebuch[Tagebuch.length] = new TagebuchEintrag(0, '');
			Titanium.API.info('Tagebuch hat jetzt ' + Tagebuch.length + ' Einträge.');

			// Farbe der Neuerstellen-Row auf schwarz ändern.
			row.color = '#000000';

			// Neuen Eintrag für Neuerstellen anfügen
			var rowNeu = Ti.UI.createTableViewRow();
			rowNeu.title = 'Neuer Eintrag...';
			tvListe.appendRow(rowNeu);
		}

		// Geänderte Werte aus der Oberfläche lesen und direkt ins Tagebuch zurückschreiben
		Tagebuch[index].Eintrag = txtEintrag.value;
		if (btnSad.borderColor=='#00ff00')
		{
			Tagebuch[index].Laune=-1;
		}
		else if (btnPlain.borderColor=='#00ff00')
		{
			Tagebuch[index].Laune=0;
		}
		else if (btnSmile.borderColor=='#00ff00')
		{
			Tagebuch[index].Laune=1;
		}

		// TableRow aus Tagebuch neu befüllen
		SetzeTableRow(row, index);

		// Tagebuch speichern
		Ti.App.Properties.setString('Tagebucheintraege', JSON.stringify(Tagebuch));
		
		// Detailfenster schliessen
		wndDetails.close();
	});

	// Ganz zum Schluss noch Löschen (außer beim Neuanlegen)
	if (index < Tagebuch.length)
	{
		var btnDelete = Titanium.UI.createButton({
			title:'Löschen',
			color:'#ff0000',
			top:340,
			width:Titanium.Platform.displayCaps.platformWidth-40,
			height:30
		});
		wndDetails.add(btnDelete);
		
		btnDelete.addEventListener('click', function()
		{
			Titanium.API.info('Eintrag löschen (' + index + ').');
	
			Tagebuch.splice(index,1);
			tvListe.deleteRow(index, {animationStyle:Titanium.UI.iPhone.RowAnimationStyle.UP});
			
			// Tagebuch speichern
			Ti.App.Properties.setString('Tagebucheintraege', JSON.stringify(Tagebuch));
			
			wndDetails.close();
		});
	}
	
	// Nachdem alles definiert ist, dass Detailfenster öffnen
	wndDetails.open();
});

// Und hier zum Schluss den TableView auf dem Bildschirm anzeigen
win.add(tvListe);

//Auf den Event von Einstellungen.js horchen
Titanium.App.addEventListener('MaxAnzahlChanged', function(e)
{
	Titanium.API.info('Titanium.App: MaxAnzahl = ' + e.MaxAnzahl + '.');
	MaxAnzahl = e.MaxAnzahl;
	
	// Das Tagebuch entsprechend kürzen
	if (Tagebuch.length > MaxAnzahl)
	{
		// Merke vorletztes Element für das Löschen der TableViewRows (letztes = Neuanlegen)
		var n = Tagebuch.length - 1;
		
		// Tagebuch kürzen
		Tagebuch.splice(MaxAnzahl, Tagebuch.length - MaxAnzahl);
		Titanium.API.info('Tagebuch gekürzt auf ' + Tagebuch.length + ' Einträge.');
		
		// Und direkt wieder speichern
		Ti.App.Properties.setString('Tagebucheintraege', JSON.stringify(Tagebuch));

		// Rows des TableViews löschen
		for (; n >= MaxAnzahl; n--)
		{
			Titanium.API.info('Lösche TabViewRow ' + n);
			tvListe.deleteRow(n);
		}
	}
});

Titanium.API.info('Liste.js Ende.');
